summaryrefslogtreecommitdiffstats
path: root/bin/cephfs-snap
diff options
context:
space:
mode:
Diffstat (limited to 'bin/cephfs-snap')
-rwxr-xr-xbin/cephfs-snap88
1 files changed, 88 insertions, 0 deletions
diff --git a/bin/cephfs-snap b/bin/cephfs-snap
new file mode 100755
index 0000000..d846ef4
--- /dev/null
+++ b/bin/cephfs-snap
@@ -0,0 +1,88 @@
+#!/bin/sh
+
+# storage-tools - Additional utilities to manage storage related tasks
+# Copyright (C) 2014-2017 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+SOFTWARE="storage-tools"
+PROGRAM="cephfs-snap"
+
+ACTION="${1}"
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} {hourly|daily|weekly|hourly}" >&2
+ exit 1
+}
+
+if [ -e "/etc/default/${SOFTWARE}" ]
+then
+ . "/etc/default/${SOFTWARE}"
+fi
+
+case "${CEPHFS_SNAP}" in
+ true)
+ ;;
+
+ *)
+ exit 0
+ ;;
+esac
+
+if [ -z "${CEPHFS_DIRECTORIES}" ]
+then
+ echo "E: no cephfs directories defined in /etc/default/${SOFTWARE}" >&2
+ exit 1
+fi
+
+case "${ACTION}" in
+ hourly|daily|weekly|monthly)
+
+ ;;
+
+ *)
+ Usage
+ ;;
+esac
+
+# Run
+DATE="$(date +%Y-%m-%d\ %H:%M:%S)"
+HOST="$(hostname -f)"
+
+TIME="$(date +%Y-%m-%d_%H%M%z)"
+SNAPSHOT="${ACTION}_${TIME}"
+
+# logfile
+echo "${DATE} ${HOST} ${PROGRAM} creating ${ACTION} snapshots" >> "/var/log/${SOFTWARE}/${PROGRAM}.log"
+
+# irc
+if [ -e /usr/bin/irk ] && [ -e "/etc/default/${SOFTWARE}" ]
+then
+ if [ -n "${IRK_TARGETS}" ]
+ then
+ for TARGET in ${IRK_TARGETS}
+ do
+ irk ${TARGET} "\x0312${HOST}:\x03 \x0303${PROGRAM}\x03 creating \x0307${ACTION}\x03 snapshots"
+ done
+ fi
+fi
+
+for CEPHFS_DIRECTORY in ${CEPHFS_DIRECTORIES}
+do
+ cd "${CEPHFS_DIRECTORY}"/.snap
+ mkdir "${SNAPSHOT}"
+done